unit udmCustomersGUI;

interface

uses
  Classes
  , udmCustomers
  , DB
  , DBTables
  ;

type
  TdmCustomersGUI = class(TdmCustomers)
    procedure CustomerBeforeDelete(DataSet: TDataSet);
    procedure OrdersBeforeDelete(DataSet: TDataSet);
    procedure ItemsBeforeDelete(DataSet: TDataSet);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

{var
  dmCustomersGUI: TdmCustomersGUI;}

implementation

uses
  Dialogs
  , SysUtils
  , Controls
  ;

{$R *.dfm}

procedure TdmCustomersGUI.CustomerBeforeDelete(DataSet: TDataSet);
begin
  // Get confirmation for the delete
  if MessageDlg('Are you sure you want to delete this Customer?',
                mtConfirmation, [mbYes, mbNo], 0) = mrNo then
  begin
    Abort;
  end;
  inherited;
end;

procedure TdmCustomersGUI.OrdersBeforeDelete(DataSet: TDataSet);
begin
  // Get confirmation for the delete
  if MessageDlg('Are you sure you want to delete this Order?',
                mtConfirmation, [mbYes, mbNo], 0) = mrNo then
  begin
    Abort;
  end;
  inherited;
end;

procedure TdmCustomersGUI.ItemsBeforeDelete(DataSet: TDataSet);
begin
  // Get confirmation for the delete
  if MessageDlg('Are you sure you want to delete this Order Item?',
                mtConfirmation, [mbYes, mbNo], 0) = mrNo then
  begin
    Abort;
  end;
  inherited;
end;

end.
