unit ufrmBase;

interface

uses
  Windows
  , Messages
  , SysUtils
  , Variants
  , Classes
  , Graphics
  , Controls
  , Forms
  , Dialogs
  , ImgList
  , DBActns
  , ActnList
  , DB
  , ComCtrls
  , ToolWin
  , Grids
  , DBGrids
  , StdCtrls
  ;

type
  TfrmBase = class(TForm)
    ImageList1: TImageList;
    ActionList1: TActionList;
    actInsert: TDataSetInsert;
    actDelete: TDataSetDelete;
    actPost: TDataSetPost;
    actCancel: TDataSetCancel;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    DSMain: TDataSource;
    Label1: TLabel;
    grdDataSet: TDBGrid;
    procedure DSMainStateChange(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    { Private declarations }

    FDM: TDataModule;

  protected

    procedure SetDM(const Value: TDataModule); virtual;

  public
    { Public declarations }

    property DM: TDataModule
      read FDM
      write SetDM;

  end;

{var
  frmBase: TfrmBase;}

implementation

{$R *.dfm}

procedure TfrmBase.DSMainStateChange(Sender: TObject);
begin
  // Enable/disable Post & Cancel for the dataset
  actPost.Enabled := Assigned(DSMain.DataSet) and
                                  (DSMain.DataSet.State in [dsEdit, dsInsert]);
  actCancel.Enabled := actPost.Enabled;
end;

procedure TfrmBase.SetDM(const Value: TDataModule);
begin
  FDM := Value;
end;

procedure TfrmBase.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose := False;
  if (Assigned(DSMain.DataSet) and
     (DSMain.DataSet.State in [dsEdit, dsInsert])) then
  begin
    case MessageDlg('Do you want to save the changes?', mtConfirmation,
                    [mbYes, mbNo, mbCancel], 0) of
      mrYes:
      begin
        DSMain.DataSet.Post;
      end;
      mrNo:
      begin
        DSMain.DataSet.Cancel;
      end;
      mrCancel:
      begin
        Abort;
      end;
    end;
    DSMain.DataSet.Close;
  end;
  CanClose := True;
end;

end.
